#!/usr/bin/env python3

import random
from os import path


VOWELS = set('aeıiouöü')


def find_what_we_know():
    with open('{}/data/we_know'.format(
            path.dirname(path.realpath(__file__)))) as f:
        lines = f.readlines()
        random_int = random.randint(0, len(lines) - 1)
        extra_spice = []
        if bool(random.choices(population=[0, 1], weights=[4, 1], k=1)[0]):
            extra_spice.append('cogiyi')
        if bool(random.choices(population=[0, 1], weights=[4, 1], k=1)[0]):
            extra_spice.append('bunlardan')
        return "Biz {} {}{} biliriz".format(
            lines[random_int].rstrip(),
            'bunlardan daha ' if 'bunlardan' in extra_spice else '',
            'çok iyi' if 'bunlardan' not in extra_spice
            and 'cogiyi' in extra_spice else 'iyi'
        )


def find_one_random(inputfile):
    with open('{}/data/{}'.format(
            path.dirname(path.realpath(__file__)), inputfile)) as f:
        lines = f.readlines()
        random_int = random.randint(0, len(lines) - 1)
        return lines[random_int].rstrip()


def find_last_vowel(word):

    for _, item in enumerate(word[::-1], 1):
        if item in VOWELS:
            return item

    raise ValueError('no vowels found, should not happen')


def format_suffix(chosen_thing):

    # Covers a nice exception, consonant changes:
    # https://www.gravityturkish.com/manisa/conmut.htm
    lv = find_last_vowel(chosen_thing)
    if lv in 'aı':
        if chosen_thing[-1] not in VOWELS:
            if chosen_thing[-1] in 'fstkçşhp':
                return 'tı'
        return 'dı'
    if lv in 'uo':
        if chosen_thing[-1] not in VOWELS:
            if chosen_thing[-1] in 'fstkçşhp':
                return 'tu'
        return 'du'
    if lv in 'üö':
        if chosen_thing[-1] not in VOWELS:
            if chosen_thing[-1] in 'fstkçşhp':
                return 'tü'
        return 'dü'

    if chosen_thing[-1] not in VOWELS:
        if chosen_thing[-1] in 'fstkçşhp':
            return 'ti'
    return 'di'


def sal_comari():
    # Pick  the special full-sentence ones (lower probability)
    if bool(random.choices(population=[0, 1], weights=[4, 1], k=1)[0]):
        return find_one_random('ozeller')

    if bool(random.choices(population=[0, 1], weights=[4, 1], k=1)[0]):
        return find_what_we_know()

    is_fixation = not bool(random.getrandbits(1))
    is_good = not bool(random.getrandbits(1))

    if is_fixation:
        entrance = find_one_random('girizgahlar_onlar_tespit')
        finishing = find_one_random('tespit_berbat')
    elif is_good:
        entrance = find_one_random('girizgahlar_bizimkiler')
        finishing = find_one_random('vaziyetler_iyi')
    else:
        entrance = find_one_random('girizgahlar_onlar')
        finishing = find_one_random('vaziyetler_berbat')
        if 'olmasaydı' in entrance:
            finishing = finishing + format_suffix(finishing)

    # Add extra spice
    if bool(random.getrandbits(1)) and is_good and not is_fixation:
        finishing = finishing + ' {}'.format(random.choice([
            'yeğenim',
            'delüğanlı',
            'çok şükür',
            'şükür'
        ]))

    return('{} {}'.format(
        entrance,
        finishing
    ))


if __name__ == "__main__":
    print(sal_comari())
